## bcalm 2.2.1

=== CMakeLists.txt ===
project(bcalm)

cmake_minimum_required(VERSION 2.6)

################################################################################
# Shortcuts
################################################################################
SET (GATB_CORE_HOME  ${PROJECT_SOURCE_DIR}/gatb-core)

################################################################################
# Define cmake modules directory
################################################################################
FOREACH (path "${CMAKE_CURRENT_SOURCE_DIR}/cmake" "${GATB_CORE_HOME}/gatb-core/cmake")
    IF (EXISTS "${path}")
        SET (CMAKE_MODULE_PATH  "${CMAKE_MODULE_PATH}" "${path}")
    ENDIF()
ENDFOREACH(path)

#############################
# getting git version
#from http://stackoverflow.com/questions/1435953/how-can-i-pass-git-sha1-to-compiler-as-definition-using-cmake
exec_program(
    "git"
    ${CMAKE_CURRENT_SOURCE_DIR}
    ARGS "rev-parse --short HEAD"
    OUTPUT_VARIABLE VERSION_SHA1 )

add_definitions( -DGIT_SHA1="${VERSION_SHA1}" )


################################################################################
# THIRD PARTIES
################################################################################

# We don't want to install some GATB-CORE artifacts
SET (GATB_CORE_EXCLUDE_TOOLS     1) # no need to compile dbgh5, etc..
SET (GATB_CORE_EXCLUDE_TESTS     1)
SET (GATB_CORE_EXCLUDE_EXAMPLES  1)


# GATB CORE
include (GatbCore)

################################################################################
#  TOOLS
################################################################################

MACRO(SUBDIRLIST result curdir)
    FILE(GLOB children RELATIVE ${curdir} ${curdir}/*)
    SET (dirlist "")
    FOREACH(child ${children})
      IF(IS_DIRECTORY ${curdir}/${child})
          LIST(APPEND dirlist ${child})
      ENDIF()
    ENDFOREACH()
    SET(${result} ${dirlist})
ENDMACRO()

# We add the compilation options for the library
add_definitions (${gatb-core-flags})

# We add the gatb-core include directory
include_directories (${gatb-core-includes})

# We add the path for extra libraries
link_directories (${gatb-core-extra-libraries-path})

set (program "bcalm")
set (PROGRAM_SOURCE_DIR ${PROJECT_SOURCE_DIR}/src)
include_directories (${PROGRAM_SOURCE_DIR})
file (GLOB_RECURSE  ProjectFiles  ${PROGRAM_SOURCE_DIR}/*.cpp)
add_executable(${program} ${ProjectFiles})
target_link_libraries(${program} ${gatb-core-libraries})

################################################################################
# DELIVERY
################################################################################

# If your current login name is different from your GForge login name, you have
# to overwrite the CPACK_USER_NAME to be the same as your GForge login
#SET (CPACK_USER_NAME                    "your_gforge_login")

# We set the version number
SET (CPACK_PACKAGE_VERSION              "")  

# We have to tell what is the server name
SET (CPACK_GFORGE_PROJECT_NAME          "gatb-tools")

# We set the kind of archive
SET (CPACK_GENERATOR                    "TGZ")
SET (CPACK_SOURCE_GENERATOR             "TGZ")

# We ignore unwanted files for the source archive
SET (CPACK_SOURCE_IGNORE_FILES
    "^${PROJECT_SOURCE_DIR}/.git/"     ;
    "^${PROJECT_SOURCE_DIR}/.gitmodules" ;
    "^${PROJECT_SOURCE_DIR}/.gitignore" ;
    "^${PROJECT_SOURCE_DIR}/build/"  ;
    "^${GATB_CORE_HOME}/.cproject" ;
    "^${GATB_CORE_HOME}/.git/"     ;
    "^${GATB_CORE_HOME}/.project"  ;
    "^${GATB_CORE_HOME}/.gitignore"
)

# We copy the project binary to the 'bin' directory
INSTALL (TARGETS ${PROJECT_NAME} DESTINATION bin)
INSTALL (DIRECTORY "${PROJECT_SOURCE_DIR}/example/" DESTINATION example)
INSTALL (FILES LICENSE README.md DESTINATION bin/..)

# cmake_system_name for mac is Darwin, i want to change that
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    set(PRETTY_SYSTEM_NAME "Linux")
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(PRETTY_SYSTEM_NAME "Mac")
endif()



file (STRINGS "VERSION" VERSION)
set (CPACK_PACKAGE_FILE_NAME  ${PROJECT_NAME}-binaries-${VERSION}-${PRETTY_SYSTEM_NAME})

include (CPack)

=== debian/changelog ===
bcalm (2.2.1-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:10:37 +0100

bcalm (2.2.1-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.4.1
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Mon, 20 Jan 2020 11:28:52 +0100

bcalm (2.2.1-1) unstable; urgency=medium

  * Initial release (Closes: #941280)

 -- Shayan Doust <hello@shayandoust.me>  Fri, 27 Sep 2019 08:49:22 +0200

=== debian/control ===
Source: bcalm
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libgatbcore-dev,
               libboost-dev,
               libhdf5-dev,
               zlib1g-dev,
               cmake
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/med-team/bcalm
Vcs-Git: https://salsa.debian.org/med-team/bcalm.git
Homepage: https://github.com/GATB/bcalm

Package: bcalm
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: de Bruijn compaction in low memory
 A bioinformatics tool for constructing the compacted de Bruijn graph
 from sequencing data.
 .
 This is the parallel version of the BCALM software using gatb-core
 library.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_install:
	dh_install
	rm -r debian/bcalm/usr/example \
		debian/bcalm/usr/README.md \
		debian/bcalm/usr/LICENSE

## bcalm 2.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,16 +17,26 @@
 ENDFOREACH(path)
 
 #############################
-# getting git version
+#getting git version
 #from http://stackoverflow.com/questions/1435953/how-can-i-pass-git-sha1-to-compiler-as-definition-using-cmake
 exec_program(
     "git"
     ${CMAKE_CURRENT_SOURCE_DIR}
     ARGS "rev-parse --short HEAD"
-    OUTPUT_VARIABLE VERSION_SHA1 )
+    OUTPUT_VARIABLE VERSION_SHA1
+    RETURN_VALUE ERROR_GIT)
 
-add_definitions( -DGIT_SHA1="${VERSION_SHA1}" )
+if(NOT ${ERROR_GIT})
+    add_definitions( -DGIT_SHA1="${VERSION_SHA1}" )
+else()
+    message("Warning: cannot retrieve git version. Bcalm won't display its version. Error value: ${ERROR_GIT})")
+endif(NOT ${ERROR_GIT})
 
+################################
+#add version nifo
+
+file (STRINGS "VERSION" VERSION)
+add_definitions( -DVERSION="${VERSION}" )
 
 ################################################################################
 # THIRD PARTIES
@@ -105,7 +115,7 @@
 # We copy the project binary to the 'bin' directory
 INSTALL (TARGETS ${PROJECT_NAME} DESTINATION bin)
 INSTALL (DIRECTORY "${PROJECT_SOURCE_DIR}/example/" DESTINATION example)
-INSTALL (FILES LICENSE README.md DESTINATION bin/..)
+INSTALL (FILES VERSION LICENSE README.md DESTINATION bin/..)
 
 # cmake_system_name for mac is Darwin, i want to change that
 if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
@@ -114,9 +124,6 @@
     set(PRETTY_SYSTEM_NAME "Mac")
 endif()
 
-
-
-file (STRINGS "VERSION" VERSION)
 set (CPACK_PACKAGE_FILE_NAME  ${PROJECT_NAME}-binaries-${VERSION}-${PRETTY_SYSTEM_NAME})
 
 include (CPack)

=== example/uf/Makefile ===
testUF: testUF.cpp ../../bglue/unionFind.hpp
	g++ -std=c++11 -o testUF testUF.cpp -fopenmp

=== debian/changelog ===
bcalm (2.2.3-6) unstable; urgency=medium

  * Team upload.
  * cmake-4.patch: new: bump cmake requirement to 3.10. (Closes: #1112722)
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/control: declare compliance to standards version 4.7.2.
  * d/watch: convert to v5 Github template.

 -- Étienne Mollier <emollier@debian.org>  Wed, 15 Oct 2025 21:52:41 +0200

bcalm (2.2.3-5) unstable; urgency=medium

  * Team upload.
  * Add build support for loongarch64
    Closes: #1058715

 -- Andreas Tille <tille@debian.org>  Tue, 09 Jan 2024 20:29:08 +0100

bcalm (2.2.3-4) unstable; urgency=medium

  * Team upload.
  * d/control: Only build on architectures supported by gatb-core.
    (Closes: #1031529)
  * d/control: Bump Standards-Version to 4.6.2; no changes needed.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Fri, 17 Feb 2023 17:01:39 -0500

bcalm (2.2.3-3) unstable; urgency=medium

  * Team upload.
  * Really fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 01 Nov 2022 19:45:44 +0100

bcalm (2.2.3-2) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 14 Oct 2021 16:41:28 +0200

bcalm (2.2.3-1) unstable; urgency=medium

  [ David Parsons ]
  * Team upload.
  * New upstream version

  [ Andreas Tille ]
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 22 Aug 2020 13:55:36 +0200

bcalm (2.2.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Overwrite upstream's simple_test with our fixed version, so we test with
    Python 3, again. And depend on it for the test. (Closes: #960876)

 -- Stefano Rivera <stefanor@debian.org>  Wed, 20 May 2020 08:51:35 -0700

bcalm (2.2.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * Don't install VERSION file to /usr

 -- Steffen Moeller <moeller@debian.org>  Tue, 05 May 2020 21:21:17 +0200

=== debian/control ===
--- 
+++ 
@@ -3,19 +3,19 @@
 Uploaders: Shayan Doust <hello@shayandoust.me>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libgatbcore-dev,
                libboost-dev,
                libhdf5-dev,
                zlib1g-dev,
                cmake
-Standards-Version: 4.4.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/bcalm
 Vcs-Git: https://salsa.debian.org/med-team/bcalm.git
 Homepage: https://github.com/GATB/bcalm
 
 Package: bcalm
-Architecture: any
+Architecture: any-amd64 arm64 loong64 mips64el ppc64el ia64 ppc64 riscv64 sparc64 alpha
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: de Bruijn compaction in low memory

=== debian/rules ===
--- 
+++ 
@@ -14,4 +14,5 @@
 	dh_install
 	rm -r debian/bcalm/usr/example \
 		debian/bcalm/usr/README.md \
-		debian/bcalm/usr/LICENSE
+		debian/bcalm/usr/LICENSE \
+		debian/bcalm/usr/VERSION

=== debian/watch ===
Version: 5

Template: Github
Owner: GATB
Project: bcalm
